#ifndef RENDER_DATA_H
#define RENDER_DATA_H
#include <gumbo.h>
#include "newsraft.h"

#define LAST_LINE line->target->lines[line->target->lines_len - 1]

struct line {
	struct render_result *target; // Render output for this line.
	size_t lim;                   // Capacity of one text line.
	size_t pin;                   // Index of the last space in the last text line.
	size_t indent;                // Shows how many spaces must be in the beginning of line.
	bool is_bold;
	bool is_underlined;
	bool is_italic;
};

bool render_text_html(struct line *line, const struct wstring *source);
void write_contents_of_html_table_node_to_text(struct line *line, GumboNode *node);

bool line_bump(struct line *line);
bool line_char(struct line *line, wchar_t c);
bool line_string(struct line *line, const wchar_t *str);
bool line_style(struct line *line, format_hint_mask hint);
#endif // RENDER_DATA_H
